Hooks:PostHook(NewRaycastWeaponBase, "init", "Aran Reload Patch", function(self, tweak_data)
	function NewRaycastWeaponBase:should_reload_immediately()
		self._should_reload_immediately = self:weapon_tweak_data().should_reload_immediately
		if self._should_reload_immediately then
			return true
		end
		return false
	end
end)

Hooks:PreHook(NewRaycastWeaponBase, "init", "Aran Reload Patch", function(self, tweak_data)
	function NewRaycastWeaponBase:fire_rate_multiplier()
		self._reload_boosts_firerate = self:weapon_tweak_data().reload_boosts_firerate
		local weap_id = self:get_name_id()
		if self._reload_boosts_firerate and self:get_ammo_max_per_clip() == 1  then
			local multiplier = 1
			
			--AGRL Basic
			for _, category in ipairs(self:weapon_tweak_data().categories) do
				multiplier = multiplier + (managers.player:upgrade_value(category, "reload_speed_multiplier", 1) - 1)
			end
			
			--AGRL Ace
			--This activates on the second shot AFTER the headshot. I'd probably have to hook in somewhere else.
			--But also Bulletstorm + AGRL Ace is too much for how easy it is to proc, so I'm not going to bother.
			--This is at least usable now, which is better than what Overkill released it as.
			--multiplier = multiplier + (managers.player:has_activate_temporary_upgrade("temporary", "single_shot_fast_reload") and 1 or 0)
			
			--Running From Death Basic
			multiplier = multiplier + (managers.player:temporary_upgrade_value("temporary", "reload_weapon_faster", 1) - 1)
			
			--Bloodthirst Ace
			multiplier = multiplier + (managers.player:get_temporary_property("bloodthirst_reload_speed", 1) - 1)
			
			--AI Reload Bonus
			multiplier = multiplier + (managers.player:upgrade_value("team", "crew_faster_reload", 1) - 1)
			
			--Swan Song Ace
			if managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier") then
				multiplier = multiplier + 1
			end
			
			--Bulletstorm Basic&Ace
			if managers.player:has_active_temporary_property("bullet_storm") then
				multiplier = multiplier + 1
			end
			
			if multiplier <= 0 then
				multiplier = 1
			end
			self._fire_rate_multiplier = multiplier
		end
		return self._fire_rate_multiplier
	end
end)